--UwU
--https://github.com/mwSora/RAID-World-War-II-luajit

if RequiredScript == "lib/units/beings/player/states/playerstandard" then
    function PlayerStandard:_check_action_throw_grenade(t, input)
        if self._ext_inventory:equipped_selection() ~= PlayerInventory.SLOT_3 then
            return
        end
    
        local action_wanted = input.btn_primary_attack_press or input.btn_primary_attack_release or input.btn_primary_attack_state
        local action_wanted_secondary = input.btn_steelsight_press or input.btn_steelsight_release or input.btn_steelsight_state
    
        if not action_wanted and not action_wanted_secondary then
            return
        end
    
        local action_forbidden = not PlayerBase.USE_GRENADES or self:chk_action_forbidden("interact") or self._unit:base():stats_screen_visible() or self:_interacting() or self:is_deploying() or self:_changing_weapon() or self:_is_meleeing() or self:_is_using_bipod()
    
        if action_forbidden then
            return
        end
    
        self:_start_action_throw_grenade(t, input, action_wanted)
    
        return action_wanted or action_wanted_secondary
    end

	function PlayerStandard:_start_action_throw_grenade(t, input, primary)
        local press = input.btn_primary_attack_press or input.btn_steelsight_press
        local release = input.btn_primary_attack_release or input.btn_steelsight_release
        local hold = input.btn_primary_attack_state or input.btn_steelsight_state
    
        if press and managers.buff_effect:is_effect_active(BuffEffectManager.EFFECT_ATTACK_ONLY_IN_AIR) and not self._state_data.in_air then
            return
        end
    
        if self._state_data.throw_high and input.btn_steelsight_release then
            return
        end
    
        if not self._state_data.throw_high and input.btn_primary_attack_release then
            return
        end
    
        local equipped_grenade = managers.blackmarket:equipped_grenade()
    
        if hold and equipped_grenade == "decoy_coin" then
            self:_interupt_action_reload(t)
            self:_interupt_action_steelsight(t)
            self:_interupt_action_running(t)
            self:_interupt_action_charging_weapon(t)
            managers.network:session():send_to_peers_synched("play_distance_interact_redirect", self._unit, "throw_grenade_charge")
    
            local throw_high = input.btn_primary_attack_press and 1 or 0
    
            self._camera_unit:anim_state_machine():set_global("throw_high", throw_high)
            self._camera_unit:anim_state_machine():set_global("throw_low", 1 - throw_high)
    
            self._state_data.throw_grenade_expire_t = t
            self._state_data.throw_high = input.btn_primary_attack_press
    
            managers.network:session():send_to_peers_synched("play_distance_interact_redirect", self._unit, "throw_grenade")
            self._ext_camera:play_redirect(Idstring("throw_grenade_now"))
        elseif press and not self:_is_throwing_grenade() and managers.player:can_throw_grenade() and equipped_grenade ~= "decoy_coin" then
            if self._state_data.throw_grenade_cooldown and t < self._state_data.throw_grenade_cooldown then
                return
            end
    
            self:_interupt_action_reload(t)
            self:_interupt_action_steelsight(t)
            self:_interupt_action_running(t)
            self:_interupt_action_charging_weapon(t)
            managers.network:session():send_to_peers_synched("play_distance_interact_redirect", self._unit, "throw_grenade_charge")
    
            local throw_high = input.btn_primary_attack_press and 1 or 0
    
            self._camera_unit:anim_state_machine():set_global("throw_high", throw_high)
            self._camera_unit:anim_state_machine():set_global("throw_low", 1 - throw_high)
    
            self._state_data.throw_grenade_expire_t = t
            self._state_data.throw_high = input.btn_primary_attack_press
            local equipped_grenade = managers.blackmarket:equipped_grenade()
            local grenade_index = tweak_data.blackmarket:get_index_from_projectile_id(equipped_grenade)
            local projectile_data = tweak_data.projectiles[equipped_grenade]
            projectile_data._rot_dir = input.btn_primary_attack_press and math.UP or math.X
            projectile_data._adjust_z = input.btn_primary_attack_press and 0 or -40
    
            if grenade_index == 4 or equipped_grenade == "dynamite" then
                self._ext_camera:play_redirect(Idstring("throw_molotov"))
            else
                self._ext_camera:play_redirect(Idstring("throw_grenade"))
    
                self._unit:equipment()._cooking_start = t
            end
    
            self:_stance_entered()
        elseif release and self._ext_camera:anim_data().throwing then
            self._state_data.throw_grenade_cooldown = t + PlayerStandard.THROW_GRENADE_COOLDOWN
    
            managers.network:session():send_to_peers_synched("play_distance_interact_redirect", self._unit, "throw_grenade")
            self._ext_camera:play_redirect(Idstring("throw_grenade_now"))
        end
    end
end